Subject: RE: [MIB-DOCTORS] FW: [Ltru] Re: Language Tag MIB Textual Convention

From: "Romascanu, Dan \(Dan\)" <[email-masked]>
Date: Thu, 9 Nov 2006 20:53:25 +0200

I believe that cross-posting between LTRU WG and MIB-Doctors list is
useful in this case. 

Juergen,

The need for a URI TC first time surfaced in the SIP MIB. Second here is
the LTRU WG facing or anticipating similar needs. 

Should we overload INET-ADDRESS-MIB with such information? I am not sure
that maintaining one module for all well-known TCs is optimal. Maybe a
better solution would be a small number of modules grouping well known
TCs - like the one ltru are discussing now. We can point to those from
the OPS Area Web pages, we plan to turn into wikis sometimes soon. 

Dan

> -----Original Message-----
> From: Juergen Schoenwaelder [mailto:[email-masked]] 
> Sent: Thursday, November 09, 2006 6:29 PM
> To: Romascanu, Dan (Dan)
> Cc: MIB Doctors; [email-masked]
> Subject: Re: [MIB-DOCTORS] FW: [Ltru] Re: Language Tag MIB 
> Textual Convention
> 
> On Thu, Nov 09, 2006 at 04:55:35PM +0200, Romascanu, Dan (Dan) wrote:
> 
> > Copying the MIB Doctors list.
> 
> So what do we do about this? We surely need generic URL/URI 
> TCs and I think those things should be hidden in some strange 
> MIBs but become a clearly identifyable reusable module.
> 
> Dan, do you have an overview where people are working already 
> and URL/URI TCs?
> 
> > Uri ::= TEXTUAL-CONVENTION
> >    DISPLAY-HINT "1024a"
> >    STATUS      current
> >    DESCRIPTION
> >             "A Uniform Resource Identifier (URI)."
> >    REFERENCE "RFC 3986 STD 66 and RFC 3305"
> >    SYNTAX      OCTET STRING (SIZE (1..1024))
> > 
> > Url ::= TEXTUAL-CONVENTION
> >    DISPLAY-HINT "1024a"
> >    STATUS      current
> >    DESCRIPTION
> >             "A Uniform Resource Locator (URL)."
> >    REFERENCE "RFC 3986 STD 66 and RFC 3305"
> >    SYNTAX      OCTET STRING (SIZE (1..1024))
> 
> I am not sure what the difference really is between these two 
> and when I should use which. I also checked the references 
> and could not find a length limitation - so we should be 
> careful to not over constrain these definitions but rather 
> spell out in the descriptions that for SNMP purposes there 
> might be length restrictions. I have not followed closely the 
> IRI work - so I do not know what the internationalization 
> aspect of this would be.
> 
> Since the INET-ADDRESS-MIB has already mutated into a 
> collection of generic TC definitions (AS numbers, port 
> numbers, IP protocol versions), one could also consider to 
> revise the INET-ADDRESS-MIB and add something like InetUri to 
> it (and if needed also InetUrl). Dan, do you have an idea how 
> you want to deal with this issue?
> 
> /js
> 
> -- 
> Juergen Schoenwaelder		 International University Bremen
> 				 (Jacobs University Bremen as 
> of Spring 2007)
> <http://www.eecs.iu-bremen.de/>	 P.O. Box 750 561, 
> 28725 Bremen, Germany
> 

_______________________________________________
MIB-DOCTORS mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/mib-doctors

---

From: "Randy Presuhn" <[email-masked]>
Date: Thu, 9 Nov 2006 18:01:19 -0800

Hi -

> From: "Romascanu, Dan (Dan)" <[email-masked]>
> To: <[email-masked]>
> Cc: "MIB Doctors" <[email-masked]>; <[email-masked]>; "Randy Presuhn" <[email-masked]>; "LTRU Working
Group" <[email-masked]>; <[email-masked]>; "Bill Fenner" <[email-masked]>
> Sent: Thursday, November 09, 2006 10:53 AM
> Subject: RE: [MIB-DOCTORS] FW: [Ltru] Re: Language Tag MIB Textual Convention
...
> the LTRU WG facing or anticipating similar needs.
...

Clarification - the ltru WG was cc-ed into this discussion
as a courtesy.  This is not part of its current work plan.

Randy, ltru co-chair

---

From: Juergen Schoenwaelder <[email-masked]>
Date: Fri, 10 Nov 2006 10:07:44 +0100

On Fri, Nov 10, 2006 at 03:47:30PM +0900, Martin Duerst wrote:

> >> I have not followed closely the 
> I happen to have followed the IRI work :-). But I'm utterly
> unfamiliar with MIB stuff. Can a 'textual convention' include
> non-ASCII characters? If yes, how does it do so? What exactly
> is a 'textual convention'? Is it something the user sees
> directly?

A textual-convention is very similar to a typedef in C. The underlying
ASN.1 base type for strings is simply a sequence of octets (an OCTET
STRING) which does not impose any meaning on the octets.

Textual-conventions can optionally have so called display hints. A
display-hint determines how an octet string value is rendered for
display purposes. This is where character set issues come into
play. There are two rendering options defined for octet strings that
contain characters:

'a' : interpret the octets contained in an octet string as ascii
      encoded characters (the text in RFC 2579 is not totally clear
      but given the history of this specification, I assume this
      essentially means US-ASCII)

't' : interpret the octets contained in an octet string as UTF-8
      encoded characters

If you do not specify a display hint, then the default rendering
likely is going to be hexadecimal. But since RFC 2579 does not specify
a default behavior, MIB people believe it is good practice to define
display hints whenever possible.

Hope this helps to understand what MIB people talk about.

/js

-- 
Juergen Schoenwaelder		 International University Bremen
				 (Jacobs University Bremen as of Spring 2007)
<http://www.eecs.iu-bremen.de/>	 P.O. Box 750 561, 28725 Bremen, Germany

---

From: Martin Duerst <[email-masked]>
Date: Fri, 10 Nov 2006 15:47:30 +0900

>I believe that cross-posting between LTRU WG and MIB-Doctors list is

Very much so, probably. If you do, please try to expand a few
acronyms more than usually.

>the LTRU WG facing or anticipating similar needs. 

Depending on how I read this sentence, I have to agree or disagree.
The work of the LTRU WG points to a need for a "Language-Tag"
TC (am I correct that this means "textual convention"?),
which may be similar in its nature as a buliding block to
an URI TC. But language tags are not URIs, so we (or language
tag users who are also MIB users, to be exact) can't use an
URI TC.

>the OPS Area Web pages, we plan to turn into wikis sometimes soon. 

I can't say much here, I'm not a MIB expert.

>> and when I should use which.

I don't see any difference at all, except for the
Identifier/Locator difference. RFC 3305
(http://www.ietf.org/rfc/rfc3305.txt), which you
have explicitly as a reference, explains carefully
why these are all one and the same thing. In particular,
see section "2.2 Contemporary View" in RFC 3305.

Unless there are some backwards compatibility issues, the best
thing is to use only one of these.

>> I also checked the references 
>> might be length restrictions.

Yes, good point.

For IRI or URI/URL only related issues in followup mails,
you may removed the LTRU WG, because the LTRU WG is about
language tags, not IRIs or URI/URLs.

Regards,    Martin.

#-#-#  Martin J. Du"rst, Assoc. Professor, Aoyama Gakuin University
#-#-#  http://www.sw.it.aoyama.ac.jp       mailto:[email-masked]

---

From: John Cowan <[email-masked]>
Date: Fri, 10 Nov 2006 09:36:45 -0500

Martin Duerst scripsit:

> But language tags are not URIs, 

Hmm.  Syntactically, they look like relative references.  Perhaps
4646bis should define a base URI so that people who want to use
URIs in place of language tags have an easy way to do so?

http://www.iana.org/assignments/language-tags/ is available.

-- 
So that's the tune they play on                 John Cowan
their fascist banjos, is it?                    [email-masked]
        --Great-Souled Sam                      http://www.ccil.org/~cowan

---

From: r&d afrac <[email-masked]>
Date: Fri, 10 Nov 2006 16:40:45 +0100

>http://www.iana.org/assignments/language-tags/ is available.

Dear John,
Beware! You may recall that this is my basic proposition and that I 
requested tags URI (RFC 4151) and IRI in various Last Calls and 
Appeals. I was banned and PR-actionned for that (and opposed by you 
in a way I will soon respect in introducing a new RFC 4646 conformant 
langtagging system - I wait for the IAB appeal responses to be sure 
that I have a clear and stable vision of RFC 4646 and of the WG-LTRU 
Charter - I know the IESG thinks you guys work more adequately when 
you disrespect your Charter along my lines ...).

The reason why I and the obvious IRI-tags were opposed is that they 
would permit to free the Internet from the 
[email-masked] controlled IANA Languages Subtags and 
Extension Registry that is supposed to become its metaroot registry - 
replacing ISO 639, 15924, 3166 and (indirectly) 15897 in becoming 
progressively uncompatible and being operated "elsewhere" as publicly 
already proposed.

ISO 11179 conformance would also do that, as will also do the MDRS. 
You see that firing the messenger did not stop the message :-)
All the best to you. Thank you for keeping working in the right direction.
jfc